
import java.util.*;
import java.awt.*;

public class Being extends Habitant{
	
	//constants
	private final double TURNINC = Math.PI*.05;
	//not a constant
	private int MAXSIZE = 9;
	

	//variables
	
	private double vx, vy;
	private double heading = 0;
	private long time = (new Date()).getTime();
	private int headcount = 0;
	private int count = 0;
	private int decaycount = 0;
	private double turn = 0;
	private double speed = .5;
	private int dir = 1 - 2*(rand.nextInt(2));
	public boolean breeding = false;
	public boolean canbreed = false;
	public int hunger = 30;
	public Being mate;
	public Traits traits = new Traits();
	
	
	public Being(float xx, float yy, float idd)
	{	
		x = xx;
		y = yy;
		traits.beingid = idd;
		initialize();
	}
	public Being()
	{
		super();
		initialize();
	}
	public void initialize()
	{
		size = 2;
		heading = rand.nextFloat() * Math.PI * 2;
		vx = speed*Math.cos(heading);
		vy =speed*Math.sin(heading);
	}
	public Point getPosition()
	{
		return new Point((int)x, (int)y);
	}
	public Point getFuturePosition(float timeelapsed)
	{
		return new Point((int) (x + vx*timeelapsed), (int) (y + vy*timeelapsed));
	}
	public void seekFood(ArrayList<Habitant> habitants)
	{
		for (Habitant b : habitants)
			if (b instanceof Food || (size >= b.size + 2 && hunger > 50))
				if (inSight(b))
				{
						heading = getAngle(b);						
					break;
				}
	}
	public Shape getContactArea()
	{
		return new Rectangle((int)(x-size/2)-3, (int)(y-size/2)-3, size+6, size+6);
	}
	public void decay()
	{
		decaycount ++;
		decaycount = decaycount % traits.decay;
		if (hunger < 0)
			hunger = 0;
		if (decaycount == 0 && MAXSIZE > 1)
		{
			if (hunger < 100)
				hunger++;

			if (hunger > 85)
			{
				size --;
				traits.maxv -= .05;
			}
			if (size <= 0)
				eaten = true;
		}
	}
	public void seekMate(ArrayList<Being> habitants)
	{
		for (Being b : habitants)
		{
			if (inSight(b) && !b.breeding && b != this && b.mate == null)
			{
					heading = getAngle(b);						
					if (getContactArea().contains(b.getX(), b.getY()))
					{
						setMate(b);//breed
						b.setMate(this);
						traits.color = new Color(rand.nextFloat()*.5f+.5f, rand.nextFloat()*.8f+.2f, .4f);
						b.traits.color = traits.color;
					}
			}
			if (inSight(b) && mate == b)
				heading = getAngle(b);
		}
		
	}
	public void setMate(Being m)
	{
		mate = m;
		breeding = true;
		if (!m.traits.color.equals(traits.color))
			traits.color = m.traits.color;
		System.out.println(traits.beingid + " : " + m.traits.beingid);
	}
	public void checkContactArea(ArrayList<Being> beings, ArrayList<Food> food)
	{
		for (Being b : beings)
			if (getContactArea().contains(b.getX(), b.getY()))
			{				
				if (size >= b.size+2 && hunger > 50)
					{
						b.eaten = true;
						if (size <= MAXSIZE)
						{size++;
						size += Math.abs(b.size/2 - 1);
						traits.maxv += .05*(Math.abs(b.size/2 - 1)+1);}
						hunger -= b.size * 5;
					}
			}
		for (Food f: food)
			
			if (getContactArea().contains(f.getX(), f.getY()))
			{		
				f.eaten = true;
				if (size < MAXSIZE)
				{
					size ++;
					traits.maxv += .05;
				}
				hunger -= 10;
			}
	}
	public void move(long nowtime, ArrayList<Being> habitants)
	{
		float timeelapsed = (nowtime - time)/12;
		vx = speed*Math.cos(heading);
		vy =speed*Math.sin(heading);
		x += (vx*(timeelapsed));
		y += (vy*(timeelapsed));
		/*{
			if (count == 0)
			{
				if (!traits.male)
					for (int i = 0; i < rand.nextInt(size); i++)//hatch
						habitants.add(new Being(x,y,traits.beingid));
				breeding = false;
			}
		}*/
		count++;
		count = count%200;
		canbreed = size >= traits.breedsize;
		time = nowtime;
		headcount ++;
		headcount = headcount % 3;
	}
	public void steer()
	{
		Point futurepos = getFuturePosition(50);
		
		if (headcount == 0)
		{
		turn = 0;
		if (futurepos.x >= SIZE)
			turn = dir*TURNINC;
		if (futurepos.x <= 0)
			turn = dir*TURNINC;
		if (futurepos.y >= SIZE)
			turn = dir*TURNINC;
		if (futurepos.y <= 0)
			turn = dir*TURNINC;		
		}
		
		
		if (turn != 0 && speed > 0)
			speed -= .15;
		else if (speed < traits.maxv)
			speed += .1;
		else if (speed > traits.maxv)
			speed = traits.maxv;
		else if (turn == 0)
			if (rand.nextFloat() > .97)
				turn = dir*TURNINC;
		heading += turn;
		heading = (heading + Math.PI*2) % (Math.PI*2);
	}
	public void step(long nowtime, ArrayList<Being> beings, ArrayList<Food> food)
	{
		move(nowtime, beings);	
		decay();
		ArrayList<Habitant> habitants = new ArrayList<Habitant>(beings);
		habitants.addAll(food);
		if (hunger < 20 && !breeding)
			seekMate(beings);
		else
		{
			seekFood(habitants);
		}
		if (breeding)
			seekMate(beings);
		checkContactArea(beings, food);
		steer();
	}
	private double getAngle(Habitant h)
	{
		double diffy = (h.getY()-y);
		double diffx = (h.getX()-x);
		double angle = Math.atan(diffy/diffx);
		angle = (angle + Math.PI*2)%(Math.PI*2);

		if (diffy > 0 && diffx < 0)
			angle += Math.PI;
		if (diffy < 0 && diffx < 0)
			angle += Math.PI;
		return angle;
	}
	private boolean inSight(Habitant h)
	{
		return (getSight().contains(h.getX(), h.getY()));
	}
	public Shape getSight()
	{		
		int retx[] = new int[3];
   		int rety[] = new int[3];
   		retx[0] = (int)x;
   		rety[0] = (int)y;
		retx[1] = (int)(x + (30 + size*2)*Math.cos(heading+Math.PI/4));
		rety[1] = (int)(y + (30 + size*2)*Math.sin(heading+Math.PI/4));
		retx[2] = (int)(x + (30 + size*2)*Math.cos(heading-Math.PI/4));
		rety[2] = (int)(y + (30 + size*2)*Math.sin(heading-Math.PI/4));
		
		return new Polygon(retx, rety, 3);
	}
	public class Traits
	{
		//traits
		public double maxv = .7 + rand.nextDouble()/2;
		public int decay = 30;
		public boolean male = rand.nextBoolean();
		public int breedsize = rand.nextInt(MAXSIZE)+3;
		public float beingid = rand.nextFloat();
		public Color color;
		public int name = rand.nextInt(10);
		public Traits()
		{
			color = Color.blue;
		}
	}
}
